//
//  FADManagerModuleInteractor.swift
//  FADSelfieTest
//
//  Created by Juan Carlos Pérez on 2/3/19.
//  Copyright (c) 2019 Juan Carlos Pérez. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

protocol FADManagerModuleBusinessLogic
{
  func doSomething(request: FADManagerModule.Something.Request)
    
    func doSelfieProcess(request: FADManagerModule.Selfie.Request)
    
}

protocol FADManagerModuleDataStore
{
  //var name: String { get set }
}

class FADManagerModuleInteractor: FADManagerModuleBusinessLogic, FADManagerModuleDataStore
{
  var presenter: FADManagerModulePresentationLogic?
  var worker: FADManagerModuleWorker?
  //var name: String = ""
  
  // MARK: Do something
  
  func doSomething(request: FADManagerModule.Something.Request)
  {
    worker = FADManagerModuleWorker()
    worker?.doSomeWork()
    
    if let imgSelfie = worker?.getUserSelfie(){
        Constants.imgSelfie = imgSelfie
    }
    
    let response = FADManagerModule.Something.Response()
    presenter?.presentSomething(response: response)
  }
    
    
    func doSelfieProcess(request: FADManagerModule.Selfie.Request){
        if let _ = request.imgSelfie{
            worker?.processSelfieModule(imgSelfie: request.imgSelfie!)
            Constants.imgSelfie = request.imgSelfie
            presenter?.presentNextModule()
        }
        else{
            print("No existe imagen que procesar")
        }
    }
    
}
